#include "OpxTDesC.h"

//-------------------------------------------------------------------------- At
//
//	DesAt%:(this&.pos&)
//
void COpxTDesC::At(OplAPI& aOplAPI)
	{
	TInt argPos = aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis)[argPos]);
	}

//-------------------------------------------------------------------- Compare
//
//	DesCompare%:(this&,des&)
//
void COpxTDesC::Compare(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->Compare(*ptrDes));
	}

//------------------------------------------------------------------- CompareC
//
//	DesCompareC%:(this&,des&)
//
void COpxTDesC::CompareC(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->CompareC(*ptrDes));
	}

//------------------------------------------------------------------- CompareF
//
//	DesCompareF%:(this&,des&)
//
void COpxTDesC::CompareF(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->CompareF(*ptrDes));
	}

//------------------------------------------------------------- Compare string
//
//	DesCompareStr%:(this&,str$)
//
void COpxTDesC::CompareStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->Compare(argStr));
	}

//---------------------------------------------------- Compare string collated
//
//	DesCompareStrC%:(this&,str$)
//
void COpxTDesC::CompareStrC(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->CompareC(argStr));
	}

//------------------------------------------------------ Compare string folded
//
//	DesCompareStrF%:(this&,str$)
//
void COpxTDesC::CompareStrF(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->CompareF(argStr));
	}

//---------------------------------------------------------------------- Equal
//
//	DesEQ%:(this&.des&)
//
void COpxTDesC::EQ(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis == *ptrDes));
	}

//--------------------------------------------------------------- Equal string
//
//	DesEQStr%:(this&.str$)
//
void COpxTDesC::EQStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis == argStr));
	}

//----------------------------------------------------------------------- Find
//
//	DesFind&:(this&,des&)
//
void COpxTDesC::Find(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Find(*ptrDes));
	}

//----------------------------------------------------------------------- FindC
//
//	DesFindC&:(this&,des&)
//
void COpxTDesC::FindC(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->FindC(*ptrDes));
	}

//----------------------------------------------------------------------- FindF
//
//	DesFindF&:(this&,des&)
//
void COpxTDesC::FindF(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->FindF(*ptrDes));
	}

//----------------------------------------------------------------- Find string
//
//	DesFindStr&:(this&,str$)
//
void COpxTDesC::FindStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Find(argStr));
	}

//-------------------------------------------------------- Find string collated
//
//	DesFindStrC&:(this&,str$)
//
void COpxTDesC::FindStrC(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->FindC(argStr));
	}

//---------------------------------------------------------- Find string folded
//
//	DesFindStrF&:(this&,str$)
//
void COpxTDesC::FindStrF(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->FindF(argStr));
	}

//------------------------------------------------------- Greater than or equal
//
//	DesGE%:(this&.des&)
//
void COpxTDesC::GE(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis >= *ptrDes));
	}

//------------------------------------------------ Greater than or equal string
//
//	DesGEStr%:(this&.str$)
//
void COpxTDesC::GEStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis >= argStr));
	}

//---------------------------------------------------------------- Greater than
//
//	DesGT%:(this&.des&)
//
void COpxTDesC::GT(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis > *ptrDes));
	}

//--------------------------------------------------------- Greater than string
//
//	DesGTStr%:(this&.str$)
//
void COpxTDesC::GTStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis > argStr));
	}

//---------------------------------------------------------- Less than or equal
//
//	DesLE%:(this&.des&)
//
void COpxTDesC::LE(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis <= *ptrDes));
	}

//--------------------------------------------------- Less than or equal string
//
//	DesLEStr%:(this&.str$)
//
void COpxTDesC::LEStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis <= argStr));
	}

//------------------------------------------------------------------------ Left
//
//	DesLeft$:(this&,len&)
//
void COpxTDesC::LeftL(OplAPI& aOplAPI)
	{
	TInt argLen = aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.PushL(ptrThis->Left(argLen));
	}

//--------------------------------------------------------------------- Length
//
//	DesLength&:(this&)
//
void COpxTDesC::Length(OplAPI& aOplAPI)
	{
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Length());
	}

//--------------------------------------------------------------------- Locate
//
//	DesLocate&:(this&,char%)
//
void COpxTDesC::Locate(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Locate(argChar));
	}

//------------------------------------------------------------- Reverse locate
//
//	DesLocateReverse&:(this&,char%)
//
void COpxTDesC::LocateReverse(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->LocateReverse(argChar));
	}

//------------------------------------------------------ Reverse locate folded
//
//	DesLocateReverseF&:(this&,char%)
//
void COpxTDesC::LocateReverseF(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->LocateReverseF(argChar));
	}

//-------------------------------------------------------------------- LocateF
//
//	DesLocateF&:(this&,char%)
//
void COpxTDesC::LocateF(OplAPI& aOplAPI)
	{
	TChar argChar = aOplAPI.PopInt16();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->LocateF(argChar));
	}

//------------------------------------------------------------------- Less than
//
//	DesLT%:(this&.des&)
//
void COpxTDesC::LT(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis < *ptrDes));
	}

//------------------------------------------------------------ Less than string
//
//	DesLTStr%:(this&.str$)
//
void COpxTDesC::LTStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis < argStr));
	}

//---------------------------------------------------------------------- Match
//
//	DesMatch&:(this&,str$)
//
void COpxTDesC::Match(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Match(*ptrDes));
	}

//--------------------------------------------------------------------- MatchC
//
//	DesMatchC&:(this&,str$)
//
void COpxTDesC::MatchC(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MatchC(*ptrDes));
	}

//--------------------------------------------------------------------- MatchF
//
//	DesMatchF&:(this&,str$)
//
void COpxTDesC::MatchF(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MatchF(*ptrDes));
	}

//--------------------------------------------------------------- Match string
//
//	DesMatchStr&:(this&,str$)
//
void COpxTDesC::MatchStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->Match(argStr));
	}

//------------------------------------------------------ Match string collated
//
//	DesMatchStrC&:(this&,str$)
//
void COpxTDesC::MatchStrC(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MatchC(argStr));
	}

//-------------------------------------------------------- Match string folded
//
//	DesMatchStrF&:(this&,str$)
//
void COpxTDesC::MatchStrF(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->MatchF(argStr));
	}

//------------------------------------------------------------------------- Mid
//
//	DesMid$:(this&,pos&,len&)
//
void COpxTDesC::MidL(OplAPI& aOplAPI)
	{
	TInt argLen = aOplAPI.PopInt32();
	TInt argPos = aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.PushL(ptrThis->Mid(argPos,argLen));
	}

//------------------------------------------------------------------- Not equal
//
//	DesNE%:(this&.des&)
//
void COpxTDesC::NE(OplAPI& aOplAPI)
	{
	TDesC* ptrDes = (TDesC*)aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis != *ptrDes));
	}

//------------------------------------------------------------ Not equal string
//
//	DesNEStr%:(this&.des&)
//
void COpxTDesC::NEStr(OplAPI& aOplAPI)
	{
	TPtrC8 argStr = aOplAPI.PopString8();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)(*ptrThis != argStr));
	}

//----------------------------------------------------------------------- Right
//
//	DesRight$:(this&,len&)
//
void COpxTDesC::RightL(OplAPI& aOplAPI)
	{
	TInt argLen = aOplAPI.PopInt32();
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.PushL(ptrThis->Right(argLen));
	}

//------------------------------------------------------------------------- Str
//
//	DesStr$:(this&)
//
void COpxTDesC::StrL(OplAPI& aOplAPI)
	{
	TDesC* ptrThis = (TDesC*)aOplAPI.PopInt32();

	aOplAPI.PushL(*ptrThis);
	}

