#include "OpxRealFormat.h"

//------------------------------------------------------------------------ New
//
//	NewRealFormat&:(this&)
//
void COpxTRealFormat::NewRealFormatL(OplAPI& aOplAPI)
	{
	aOplAPI.Push((TInt32)new (ELeave) TRealFormat());
	}
//--------------------------------------------------------------------- Delete
//
//	DeleteRealFormat:(BYREF this&)
//
void COpxTRealFormat::DeleteRealFormat(OplAPI& aOplAPI)
	{
	TAny *ptrLong = aOplAPI.PopPtrInt32();

	TRealFormat* ptrThis = (TRealFormat*)OplAPI::GetLong(ptrLong);
	delete ptrThis;
	OplAPI::PutLong(ptrLong,0);
	aOplAPI.Push(0.0);
	}
//----------------------------------------------------------------------- Type
//
//	RealFormatType&:(this&)
//
void COpxTRealFormat::Type(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->iType);
	}

//---------------------------------------------------------------------- Width
//
//	RealFormatWidth&:(this&)
//
void COpxTRealFormat::Width(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->iWidth);
	}

//--------------------------------------------------------------------- Places
//
//	RealFormatPlaces&:(this&)
//
void COpxTRealFormat::Places(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->iPlaces);
	}

//---------------------------------------------------------------------- Point
//
//	RealFormatPoint%:(this&)
//
void COpxTRealFormat::Point(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->iPoint);
	}

//---------------------------------------------------------------------- Triad
//
//	RealFormatTriad%:(this&)
//
void COpxTRealFormat::Triad(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt16)ptrThis->iTriad);
	}

//--------------------------------------------------------------------- TriLen
//
//	RealFormatTriLen&:(this&)
//
void COpxTRealFormat::TriLen(OplAPI& aOplAPI)
	{
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	aOplAPI.Push((TInt32)ptrThis->iTriLen);
	}
//------------------------------------------------------------------- Set type
//
//	RealFormatSetType:(this&,type&)
//
void COpxTRealFormat::SetType(OplAPI& aOplAPI)
	{
	TInt argType = aOplAPI.PopInt32();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iType = argType;
	aOplAPI.Push(0.0);
	}

//------------------------------------------------------------------ Set width
//
//	RealFormatSetWidth&:(this&,width&)
//
void COpxTRealFormat::SetWidth(OplAPI& aOplAPI)
	{
	TInt argWidth = aOplAPI.PopInt32();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iWidth = argWidth;
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------------- Places
//
//	RealFormatPlaces&:(this&,places&)
//
void COpxTRealFormat::SetPlaces(OplAPI& aOplAPI)
	{
	TInt argPlaces = aOplAPI.PopInt32();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iPlaces = argPlaces;
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------------- Point
//
//	RealFormatPoint%:(this&,point%)
//
void COpxTRealFormat::SetPoint(OplAPI& aOplAPI)
	{
	TChar argPoint = aOplAPI.PopInt16();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iPoint = argPoint;;
	aOplAPI.Push(0.0);
	}

//---------------------------------------------------------------------- Triad
//
//	RealFormatTriad%:(this&,triad%)
//
void COpxTRealFormat::SetTriad(OplAPI& aOplAPI)
	{
	TChar argTriad = aOplAPI.PopInt16();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iTriad = argTriad;
	aOplAPI.Push(0.0);
	}

//--------------------------------------------------------------------- TriLen
//
//	RealFormatTriLen&:(this&,trilen&)
//
void COpxTRealFormat::SetTriLen(OplAPI& aOplAPI)
	{
	TInt argTriLen = aOplAPI.PopInt32();
	TRealFormat* ptrThis = (TRealFormat*)aOplAPI.PopInt32();

	ptrThis->iTriLen = argTriLen;
	aOplAPI.Push(0.0);
	}
