#ifndef _OPXTDES_H
#define	_OPXTDES_H

#ifndef __OPLAPI_H__
#include <oplapi.h>
#endif

class COpxTDes
	{
public:
	// the OPX extension methods
	static void Append		(OplAPI& aOplAPI);
	static void AppendChar		(OplAPI& aOplAPI);
	static void AppendFill		(OplAPI& aOplAPI);
	static void AppendJustify	(OplAPI& aOplAPI);
	static void AppendJustifyStr	(OplAPI& aOplAPI);
	static void AppendNum		(OplAPI& aOplAPI);
	static void AppendNumFloat	(OplAPI& aOplAPI);
	static void AppendNumRadix	(OplAPI& aOplAPI);
	static void AppendNumRadixUC	(OplAPI& aOplAPI);
	static void AppendStr		(OplAPI& aOplAPI);
	static void Capitalize		(OplAPI& aOplAPI);
	static void Collate		(OplAPI& aOplAPI);
	static void Copy		(OplAPI& aOplAPI);
	static void CopyC		(OplAPI& aOplAPI);
	static void CopyCP		(OplAPI& aOplAPI);
	static void CopyF		(OplAPI& aOplAPI);
	static void CopyLC		(OplAPI& aOplAPI);
	static void CopyUC		(OplAPI& aOplAPI);
	static void CopyStr		(OplAPI& aOplAPI);
	static void CopyStrC		(OplAPI& aOplAPI);
	static void CopyStrCP		(OplAPI& aOplAPI);
	static void CopyStrF		(OplAPI& aOplAPI);
	static void CopyStrLC		(OplAPI& aOplAPI);
	static void CopyStrUC		(OplAPI& aOplAPI);
	static void Delete		(OplAPI& aOplAPI);
	static void Fill		(OplAPI& aOplAPI);
	static void FillLen		(OplAPI& aOplAPI);
	static void FillZ		(OplAPI& aOplAPI);
	static void FillZLen		(OplAPI& aOplAPI);
	static void Fold		(OplAPI& aOplAPI);
	static void Insert		(OplAPI& aOplAPI);
	static void InsertStr		(OplAPI& aOplAPI);
	static void Justify		(OplAPI& aOplAPI);
	static void JustifyStr		(OplAPI& aOplAPI);
	static void LowerCase		(OplAPI& aOplAPI);
	static void MaxLength		(OplAPI& aOplAPI);
	static void Num			(OplAPI& aOplAPI);
	static void NumFloat		(OplAPI& aOplAPI);
	static void NumRadix		(OplAPI& aOplAPI);
	static void NumRadixUC		(OplAPI& aOplAPI);
	static void Repeat		(OplAPI& aOplAPI);
	static void RepeatStr		(OplAPI& aOplAPI);
	static void Replace		(OplAPI& aOplAPI);
	static void ReplaceStr		(OplAPI& aOplAPI);
	static void SetLength		(OplAPI& aOplAPI);
	static void SetMax		(OplAPI& aOplAPI);
	static void Swap		(OplAPI& aOplAPI);
	static void Trim		(OplAPI& aOplAPI);
	static void TrimAll		(OplAPI& aOplAPI);
	static void TrimLeft		(OplAPI& aOplAPI);
	static void TrimRight		(OplAPI& aOplAPI);
	static void UpperCase		(OplAPI& aOplAPI);
	static void Zero		(OplAPI& aOplAPI);
	static void ZeroTerminate	(OplAPI& aOplAPI);
	};

#endif // _OPXTDES_H
