#ifndef _OPXTLEX_H
#define _OPXTLEX_H

#ifndef __OPLAPI_H__
#include <oplapi.h>
#endif

class COpxTLex  
{
public:
	// the OPX extension methods
	static void NewLexL		(OplAPI& aOplAPI);
	static void NewLex2L		(OplAPI& aOplAPI);
	static void NewLex3L		(OplAPI& aOplAPI);
	static void NewLex4L		(OplAPI& aOplAPI);
	static void DeleteLex		(OplAPI& aOplAPI);
	static void Assign		(OplAPI& aOplAPI);
	static void AssignDes		(OplAPI& aOplAPI);
	static void AssignStr		(OplAPI& aOplAPI);
	static void Eos			(OplAPI& aOplAPI);
	static void Get			(OplAPI& aOplAPI);
	static void Inc			(OplAPI& aOplAPI);
	static void Mark		(OplAPI& aOplAPI);
	static void MarkedOffset	(OplAPI& aOplAPI);
	static void MarkedTokenL	(OplAPI& aOplAPI);
	static void MarkedTokenStrL	(OplAPI& aOplAPI);
	static void NextTokenL		(OplAPI& aOplAPI);
	static void NextTokenStrL	(OplAPI& aOplAPI);
	static void Offset		(OplAPI& aOplAPI);
	static void Peek		(OplAPI& aOplAPI);
	static void RemainderL		(OplAPI& aOplAPI);
	static void RemainderStrL	(OplAPI& aOplAPI);
	static void RemainderFromMarkL	(OplAPI& aOplAPI);
	static void RemainderFromMarkStrL(OplAPI& aOplAPI);
	static void SkipAndMark		(OplAPI& aOplAPI);
	static void SkipCharacters	(OplAPI& aOplAPI);
	static void SkipSpace		(OplAPI& aOplAPI);
	static void SkipSpaceAndMark	(OplAPI& aOplAPI);
	static void TokenLength		(OplAPI& aOplAPI);
	static void UnGet		(OplAPI& aOplAPI);
	static void UnGetToMark		(OplAPI& aOplAPI);
	static void Val			(OplAPI& aOplAPI);
	static void ValFloat		(OplAPI& aOplAPI);
	static void ValRadix		(OplAPI& aOplAPI);
	static void ValRadixLimit	(OplAPI& aOplAPI);
};

#endif // _OPXTLEX_H
